## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# adapted with love from sqlite

%bcond_without check
# docs are empty at this time
%bcond_with doc
%bcond_without static

%global gittagversion 1.15.3
%global gittag v%{?gittagversion}

Name:           cowsql
Version:        %{gittagversion}
Release:        %autorelease
Summary:        Embeddable, replicated and fault tolerant SQL engine

License:        LGPL-3.0-only
URL:            https://github.com/cowsql/cowsql/
Source:         %{url}/archive/%{gittag}/%{name}-%{version}.tar.gz

%if 0%{?fedora}
Patch:          fix-rtd-deprecation.patch
%endif

Provides:       libcowsql

# tool requirements
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc
BuildRequires:  libtool
BuildRequires:  make
# cowsql
BuildRequires:  libuv-devel
BuildRequires:  raft-devel
BuildRequires:  sqlite-devel

# docs
%if %{with doc}
BuildRequires:  python-sphinx
#BuildRequires:  python-mock
#BuildRequires:  python-alabaster
#BuildRequires:  python-commonmark
BuildRequires:  python-sphinx_rtd_theme
BuildRequires:  python-recommonmark
%endif

%description
cowsql is a C library that implements an embeddable and
replicated SQL database engine with high availability and automatic failover.

cowsql extends SQLite with a network protocol that can connect together various
instances of your application and have them act as a highly-available cluster,
with no dependency on external databases.

The name "cowsql" loosely refers to the "pets vs. cattle" concept, since it's
generaly fine to delete or rebuild a particular node of an application that
uses cowsql for data storage.

%package devel
Summary: Development tools for the cowsql embeddable SQL database engine
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: pkgconfig
Provides: lib%{name}-devel

%description devel
This package contains the header files and development documentation 
for %{name}. If you like to develop programs using %{name}, you will need 
to install %{name}-devel.

%if %{with doc}
%package doc
Summary: Documentation for libcowsql
BuildArch: noarch
 
%description doc
This package contains most of the static HTML files that comprise the
cowsql.dev website
%endif

%prep
%autosetup -p1 -n %{name}-%{version}

sed -i 's/1.14.0/%{version}/' configure.ac

autoreconf -iv

%build
%configure
%make_build

%if %{with doc}
sphinx-build-3 -b html docs html
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%make_install

%if ! 0%{with static}
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.{la,a}
%endif

%if %{with check}
%check
make check
%endif

%files
%license LICENSE
%doc AUTHORS README.md

%{_libdir}/lib%{name}.so.0
%{_libdir}/lib%{name}.so.0.*
 
%files devel
%{_includedir}/%{name}.h
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/cowsql.pc

%if 0%{with static}
%{_libdir}/lib%{name}.a
%exclude %{_libdir}/*.la
%endif

%if %{with doc}
%files doc
%doc html
%endif

%changelog
* Wed Nov 01 2023 Neil Hanlon <neil@rockylinux.org> - 1.15.3-4
- Uncommitted changes

* Wed Nov 01 2023 Neil Hanlon <neil@shrug.pw> - 1.15.3-3
- Add doc pkg

* Wed Nov 01 2023 Neil Hanlon <neil@shrug.pw> - 1.15.3-2
- init package

* Tue Oct 31 2023 Neil Hanlon <neil@shrug.pw> - 1.15.3-1
- initial pkg
